SystemOrganization addCategory: #ConfigurationOfOCompletion!

Object subclass: #ConfigurationOfOCompletion
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfOCompletion'!

!ConfigurationOfOCompletion commentStamp: 'StephaneDucasse 2/23/2012 08:29' prior: 0!
(ConfigurationOfOCompletion project version: '1.4') load

!

!ConfigurationOfOCompletion class methodsFor: 'private' stamp: 'MarianoMartinezPeck 12/18/2009 17:11'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfOCompletion class methodsFor: 'private' stamp: 'DaleHenrichs 12/29/2009 17:53'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load latest version of Metacello, load a specific version if desired"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #loadLatestVersion ]! !

!ConfigurationOfOCompletion class methodsFor: 'metacello tool support' stamp: 'MarianoMartinezPeck 12/18/2009 17:11'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfOCompletion class methodsFor: 'metacello tool support' stamp: 'MarianoMartinezPeck 12/18/2009 17:11'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfOCompletion class methodsFor: 'metacello tool support' stamp: 'GuillermoPolito 1/13/2012 09:49'!
loadStable
	^(self project version: #stable) load! !

!ConfigurationOfOCompletion class methodsFor: 'metacello tool support' stamp: 'MarianoMartinezPeck 12/18/2009 17:11'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfOCompletion class methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/18/2009 17:11'!
project

	^self new project! !

!ConfigurationOfOCompletion methodsFor: 'baselines' stamp: 'DaleHenrichs 2/6/2010 19:46'!
baseline10: spec 
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
	].	
		
	spec for: #pharo do: [
		spec repository: 'http://www.squeaksource.com/OCompletion'.
		spec
			project: 'Shout' with: [
				spec
					className: 'ConfigurationOfShout';
					loads: #('Core' );
					file: 'ConfigurationOfShout';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'Shout Tests' 
				copyFrom: 'Shout' 
				with: [ spec loads: #('Tests' ).].

		spec 
			package: 'Ocompletion' with: [ 
				spec 
					requires: #('Shout' 'RoelTyper');
					supplyingAnswers:  {{ 'list of packages'. 'Kernel* Collection*' }}];
			package: 'OcompletionTests' with: [ spec requires: 'Ocompletion' ];
			package: 'RoelTyper' with: [ 
				spec repository: 'http://www.squeaksource.com/RoelTyper' ].	
		
		
		spec
			group: 'default' with: #('Core' );
			group: 'Core' with: #( 'Ocompletion' );
			group: 'Tests' with: #( 'OcompletionTests' 'Shout Tests' "RoelTyper Tests" );
			group: 'Core Tests' with: #('Core' 'Tests' );
			
			yourself.	
			
	]! !

!ConfigurationOfOCompletion methodsFor: 'baselines' stamp: 'ul 2/8/2011 20:55'!
baseline11: spec 
	<version: '1.1-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
	].	
		
	spec for: #squeakCommon do: [
		spec repository: 'http://www.squeaksource.com/OCompletion'.
		spec
			project: 'Shout' with: [
				spec
					className: 'ConfigurationOfShout';
					loads: #('Core' );
					file: 'ConfigurationOfShout';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'Shout Tests' 
				copyFrom: 'Shout' 
				with: [ spec loads: #('Tests' ).].

		spec
			package: 'OcompletionTests' with: [ spec requires: 'Ocompletion' ];
			package: 'RoelTyper' with: [ 
				spec repository: 'http://www.squeaksource.com/RoelTyper' ].
		
		
		spec
			group: 'default' with: #('Core' );
			group: 'Core' with: #( 'Ocompletion' );
			group: 'Tests' with: #( 'OcompletionTests' 'Shout Tests' "RoelTyper Tests" );
			group: 'Core Tests' with: #('Core' 'Tests' );
			yourself.
	].

	spec for: #pharo do: [
		spec package: 'Ocompletion' with: [ 
			spec 
				requires: #('Shout' 'RoelTyper');
				supplyingAnswers:  {{ 'list of packages'. 'Kernel* Collection*' }}];
			yourself.
	].

	spec for: #squeak do: [
		spec package: 'Ocompletion' with: [ 
			spec 
				requires: #('Shout' 'RoelTyper');
				supplyingAnswers:  {{ 'list of packages'. 'Kernel* Collection*' }} ];
			yourself.
		spec package: 'OcompletionSqueakCompatibility'  with: [
			spec requires: 'Ocompletion' ].
		spec
			group: 'Core' with: #( 'Ocompletion'  'OcompletionSqueakCompatibility')
	].	! !

!ConfigurationOfOCompletion methodsFor: 'baselines' stamp: 'ul 2/8/2011 19:49'!
baseline12: spec 
	<version: '1.2-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
	].	
		
	spec for: #squeakCommon do: [
		spec repository: 'http://www.squeaksource.com/OCompletion'.
		spec
			project: 'Shout' with: [
				spec
					className: 'ConfigurationOfShout';
					loads: #('Core' );
					file: 'ConfigurationOfShout';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'Shout Tests' 
				copyFrom: 'Shout' 
				with: [ spec loads: #('Tests' ).].

		spec
			package: 'OcompletionTests' with: [ spec requires: 'Ocompletion' ];
			package: 'RoelTyper' with: [ 
				spec repository: 'http://www.squeaksource.com/RoelTyper' ].
		
		
		spec
			group: 'default' with: #('Core' );
			group: 'Core' with: #( 'Ocompletion' );
			group: 'Tests' with: #( 'OcompletionTests' 'Shout Tests' "RoelTyper Tests" );
			group: 'Core Tests' with: #('Core' 'Tests' );
			yourself.
	
		spec package: 'Ocompletion' with: [ 
			spec 
				requires: #('Shout' 'RoelTyper');
				supplyingAnswers:  {{ 'list of packages'. 'Kernel* Collection*' }};
				postLoadDoIt: #postLoadSqueak ];
			yourself.
	].! !

!ConfigurationOfOCompletion methodsFor: 'baselines' stamp: 'ul 3/2/2013 02:13'!
baseline13: spec 
	<version: '1.3-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
	].	
		
	spec for: #squeakCommon do: [
		spec repository: 'http://www.squeaksource.com/OCompletion'.
		spec
			project: 'Shout' with: [
				spec
					className: 'ConfigurationOfShout';
					loads: #('Core' );
					file: 'ConfigurationOfShout';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'Shout Tests' 
				copyFrom: 'Shout' 
				with: [ spec loads: #('Tests' ).].

		spec
			package: 'OcompletionTests' with: [ spec requires: 'Ocompletion' ];
			package: 'RoelTyper' with: [ 
				spec repository: 'http://www.squeaksource.com/RoelTyper' ].
		
		spec
			group: 'default' with: #('Core' );
			group: 'Core' with: #( 'Ocompletion' );
			group: 'Tests' with: #( 'OcompletionTests' 'Shout Tests');
			group: 'Core Tests' with: #('Core' 'Tests' );
			yourself.
	].


	spec for: #pharo do: [
		
			spec package: 'Ocompletion' with: [ 
			spec 
				requires: #('Shout' 'RoelTyper');
				postLoadDoIt: #postLoadSqueak];
			yourself.
			
			spec package: 'OcompletionPharoCompatibility'  with: [
				spec requires: 'Ocompletion' ].
			
			spec
				group: 'Core' with: #( 'Ocompletion'  'OcompletionPharoCompatibility').
	
	].

	spec for: #squeak do: [
		
			spec package: 'Ocompletion' with: [ 
				spec 
					requires: #('Shout' 'RoelTyper');
					supplyingAnswers:  {{ 'list of packages'. 'Kernel* Collection*' }};
					postLoadDoIt: #postLoadSqueak ].
				
			spec package: 'OcompletionSqueakCompatibility'  with: [
				spec requires: 'Ocompletion' ].
			
			spec
				group: 'Core' with: #('Ocompletion' 'OcompletionSqueakCompatibility').
	
	] ! !

!ConfigurationOfOCompletion methodsFor: 'post load' stamp: 'tfel 10/28/2010 18:35:44.868'!
postLoadSqueak

	Smalltalk at: #ECToolSet ifPresent: [ :ecToolSet |
		ecToolSet register.
		ToolSet default: ecToolSet ].! !

!ConfigurationOfOCompletion methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 12/18/2009 17:11'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear.
		project ]! !

!ConfigurationOfOCompletion methodsFor: 'versions' stamp: 'BenjaminVanRyseghem 6/9/2011 17:10'!
resetDefaultToolSet

	Smalltalk tools initDefaultToolSet ! !

!ConfigurationOfOCompletion methodsFor: 'symbolic versions' stamp: 'ul 3/2/2013 02:26'!
stable: spec 
	<symbolicVersion: #stable>
	
	spec for: #'pharo1.0.x' version: '1.1'. 
	spec for: #'pharo1.1.x' version: '1.1.2'. 
	spec for: #'pharo1.2.x' version: '1.2.2'. 
	spec for: #'pharo1.3.x' version: '1.3'. 
	spec for: #'pharo1.4.x' version: '1.4.1'.
	spec for: #'squeak4.1.x' version: '1.1.2'.
	spec for: #'squeak4.2.x' version: '1.2.2'.
	spec for: #'squeak4.3.x' version: '1.4.2'.
	spec for: #'squeak4.4.x' version: '1.4.2'.
	spec for: #'squeak4.x' version: '1.4.2'.
! !

!ConfigurationOfOCompletion methodsFor: 'versions' stamp: 'DaleHenrichs 2/6/2010 19:48'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'MarianoMartinezPeck'.
		spec description: 'First release 1.0 of this project '.
	].
		
	spec for: #pharo do: [
		spec 
			project: 'Shout' with: '1.0';
			project: 'Shout Tests' with: '1.0'.
		
		spec	
			package: 'Ocompletion' with: 'Ocompletion-RomainRobbes.52';
			package: 'OcompletionTests' with: 'OcompletionTests-MarianoMartinezPeck.3';
			package: 'RoelTyper' with: 'RoelTyper-DamienCassou.80'.

	]
			! !

!ConfigurationOfOCompletion methodsFor: 'versions' stamp: 'MarianoMartinezPeck 6/6/2010 20:36'!
version111: spec
	<version: '1.1.1' imports: #('1.1-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'Alexandre Bergel'.
		spec description: '- Fix the override of the tests '.
	].
		
	spec for: #pharo do: [
		spec 
			project: 'Shout' with: '1.1';
			project: 'Shout Tests' with: '1.1'.
		
		spec	
			package: 'Ocompletion' with: 'Ocompletion-MarianoMartinezPeck.60';
			package: 'OcompletionTests' with: 'OcompletionTests-MarianoMartinezPeck.3';
			package: 'RoelTyper' with: 'RoelTyper-DamienCassou.80'.

	]
			! !

!ConfigurationOfOCompletion methodsFor: 'versions' stamp: 'ul 2/8/2011 20:00'!
version112: spec
	<version: '1.1.2' imports: #('1.1-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'Mariano Martinez Peck'.
		spec description: '- '.
	].
		
	spec for: #pharo do: [
		spec 
			project: 'Shout' with: '1.1';
			project: 'Shout Tests' with: '1.1'.
		
		spec	
			package: 'Ocompletion' with: 'Ocompletion-MarianoMartinezPeck.63';
			package: 'OcompletionTests' with: 'OcompletionTests-MarianoMartinezPeck.3';
			package: 'RoelTyper' with: 'RoelTyper-MarianoMartinezPeck.81'.

	].

	spec for: #squeak do: [
		spec 
			project: 'Shout' with: '1.1.1';
			project: 'Shout Tests' with: '1.1.1'.
		
		spec	
			package: 'Ocompletion' with: 'Ocompletion-ul.73';
			package: 'OcompletionTests' with: 'OcompletionTests-ul.5';
			package: 'RoelTyper' with: 'RoelTyper-FredericPluquet.82';
			package: 'OcompletionSqueakCompatibility' with: 'OcompletionSqueakCompatibility-ul.1'

	].	
			! !

!ConfigurationOfOCompletion methodsFor: 'versions' stamp: 'DaleHenrichs 2/6/2010 19:48'!
version11: spec
	<version: '1.1' imports: #('1.1-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'MarianoMartinezPeck'.
		spec description: '- Fix the override of the tests '.
	].
		
	spec for: #pharo do: [
		spec 
			project: 'Shout' with: '1.0';
			project: 'Shout Tests' with: '1.0'.
		
		spec	
			package: 'Ocompletion' with: 'Ocompletion-RomainRobbes.52';
			package: 'OcompletionTests' with: 'OcompletionTests-MarianoMartinezPeck.3';
			package: 'RoelTyper' with: 'RoelTyper-DamienCassou.80'.

	]
			! !

!ConfigurationOfOCompletion methodsFor: 'versions' stamp: 'GuillermoPolito 11/14/2010 17:01'!
version121: spec
	<version: '1.2.1' imports: #('1.2-baseline')>

	spec for: #common do: [
		spec blessing: #development.
		spec author: 'Guillermo Polito'.
		spec description: 'OCompletion for Pharo 1.2'.
	].
		
	spec for: #pharo do: [
		
		spec 
			project: 'Shout' with: '1.2.1';
			project: 'Shout Tests' with: '1.2.1'.
		
		spec	
			package: 'Ocompletion' with: 'Ocompletion-ul.81';
			package: 'OcompletionTests' with: 'OcompletionTests-ul.7';
			package: 'RoelTyper' with: 'RoelTyper-FredericPluquet.82'.
	].

	spec for: #squeak do: [
		
		spec 
			project: 'Shout' with: '1.1.1';
			project: 'Shout Tests' with: '1.1.1'.
		
		spec	
			package: 'Ocompletion' with: 'Ocompletion-ul.74';
			package: 'OcompletionTests' with: 'OcompletionTests-MarianoMartinezPeck.3';
			package: 'RoelTyper' with: 'RoelTyper-FredericPluquet.82'.
	]! !

!ConfigurationOfOCompletion methodsFor: 'versions' stamp: 'GuillermoPolito 3/13/2011 16:13'!
version122: spec
	<version: '1.2.2' imports: #('1.2-baseline')>

	spec for: #common do: [
		spec blessing: #release.
		spec author: 'Francisco Ortiz Pealoza'.
		spec description: 'OCompletion for Pharo 1.2 with editor changes'.
	].
		
	spec for: #pharo do: [
		
		spec 
			project: 'Shout' with: '1.2.2';
			project: 'Shout Tests' with: '1.2.2'.
		
		spec	
			package: 'Ocompletion' with: 'Ocompletion-ul.92';
			package: 'OcompletionTests' with: 'OcompletionTests-ul.10';
			package: 'RoelTyper' with: 'RoelTyper-FredericPluquet.82'.
	].

	spec for: #squeak do: [
		
		spec 
			project: 'Shout' with: '1.1.1';
			project: 'Shout Tests' with: '1.1.1'.
		
		spec	
			package: 'Ocompletion' with: 'Ocompletion-ul.92';
			package: 'OcompletionTests' with: 'OcompletionTests-ul.10';
			package: 'RoelTyper' with: 'RoelTyper-FredericPluquet.82'.
	]! !

!ConfigurationOfOCompletion methodsFor: 'versions' stamp: 'GuillermoPolito 11/14/2010 17:04'!
version12: spec
	<version: '1.2' imports: #('1.1-baseline')>

	spec for: #common do: [
		spec blessing: #development.
		spec author: 'Mariano Martinez Peck'.
		spec description: '- '.
	].
		
	spec for: #pharo do: [
		
		spec 
			project: 'Shout' with: '1.2';
			project: 'Shout Tests' with: '1.2'.
		
		spec	
			package: 'Ocompletion' with: 'Ocompletion-RomainRobbes.65';
			package: 'OcompletionTests' with: 'OcompletionTests-MarianoMartinezPeck.3';
			package: 'RoelTyper' with: 'RoelTyper-FredericPluquet.82'.
	].

	spec for: #squeak do: [
		
		spec 
			project: 'Shout' with: '1.1.1';
			project: 'Shout Tests' with: '1.1.1'.
		
		spec	
			package: 'Ocompletion' with: 'Ocompletion-ul.74';
			package: 'OcompletionTests' with: 'OcompletionTests-MarianoMartinezPeck.3';
			package: 'RoelTyper' with: 'RoelTyper-FredericPluquet.82'.
	]! !

!ConfigurationOfOCompletion methodsFor: 'versions' stamp: 'NorbertHartl 2/22/2012 11:53'!
version13: spec
	<version: '1.3' imports: #('1.2-baseline')>

	spec for: #common do: [
		spec blessing: #development.
		spec author: 'Mariano Martinez Peck'.
		spec description: 'OCompletion for Pharo 1.3'.
	].
		
	spec for: #pharo do: [
		
		spec 
			project: 'Shout' with: '1.3';
			project: 'Shout Tests' with: '1.3'.
		
		spec	
			package: 'Ocompletion' with: 'Ocompletion-ul.102';
			package: 'OcompletionTests' with: 'OcompletionTests-ul.10';
			package: 'RoelTyper' with: 'RoelTyper-FredericPluquet.82'.
	 ].
	spec for: #'pharo1.3.x'  do: [
		spec
			package: 'OcompletionPharoCompatibility' with: 'OcompletionPharoCompatibility-GuillermoPolito.10'.
	].

	spec for: #squeak do: [
		
		spec 
			project: 'Shout' with: '1.1.1';
			project: 'Shout Tests' with: '1.1.1'.
		
		spec	
			package: 'Ocompletion' with: 'Ocompletion-MarianoMartinezPeck.98';
			package: 'OcompletionTests' with: 'OcompletionTests-ul.10';
			package: 'RoelTyper' with: 'RoelTyper-FredericPluquet.82'.
	]! !

!ConfigurationOfOCompletion methodsFor: 'versions' stamp: 'EstebanLorenzano 4/9/2012 11:45'!
version141: spec
	<version: '1.4.1' imports: #('1.4')>

	spec for: #common do: [
		spec blessing: #development.
		spec author: 'EstebanLorenzano'.
		spec description: 'OCompletion for Pharo 1.4' ].
		
	spec for: #pharo do: [
		spec package: 'Ocompletion' with: 'Ocompletion-EstebanLorenzano.117' ].! !

!ConfigurationOfOCompletion methodsFor: 'versions' stamp: 'ul 3/2/2013 02:25'!
version142: spec
	<version: '1.4.2' imports: #('1.3-baseline')>

	spec for: #common do: [
		spec blessing: #development.
		spec author: 'topa'.
		spec description: 'OCompletion for Squeak 4'.
		spec timestamp:  "TimeStamp now" '25 February 2013 8:41:21 pm'.
	].
		
	spec for: #squeakCommon do: [
		spec package: 'Ocompletion' with: 'Ocompletion-EstebanLorenzano.117'.
	].
			
	spec for: #pharo do: [
		
		spec 
			project: 'Shout' with: '1.3';
			project: 'Shout Tests' with: '1.3'.
		
		spec	
			package: 'OcompletionPharoCompatibility' with: 'OcompletionPharoCompatibility-GuillermoPolito.10';
			package: 'OcompletionTests' with: 'OcompletionTests-ul.10';
			package: 'RoelTyper' with: 'RoelTyper-FredericPluquet.82'.
			
		spec postLoadDoIt: #resetDefaultToolSet.
	].

	spec for: #'pharo1.3.x'  do: [
		spec
			package: 'OcompletionPharoCompatibility' with: 'OcompletionPharoCompatibility-GuillermoPolito.10'.
	].

	spec for: #squeak do: [
		
		spec 
			project: 'Shout' with: '1.2.2';
			project: 'Shout Tests' with: '1.2.2'.
		spec
			package: 'OcompletionSqueakCompatibility' with: 'OcompletionSqueakCompatibility-JohnMcKeon.3';
			package: 'OcompletionTests' with: 'OcompletionTests-ul.10';
			package: 'RoelTyper' with: 'RoelTyper-AlexandreBergel.85'.
		spec postLoadDoIt: #postLoadSqueak
	]! !

!ConfigurationOfOCompletion methodsFor: 'versions' stamp: 'BenjaminVanRyseghem 2/23/2012 16:54'!
version14: spec
	<version: '1.4' imports: #('1.3-baseline')>

	spec for: #common do: [
		spec blessing: #development.
		spec author: 'Guillermo Polito'.
		spec description: 'OCompletion for Pharo 1.4'.
	].
		
	spec for: #pharo do: [
		
		spec 
			project: 'Shout' with: '1.3';
			project: 'Shout Tests' with: '1.3'.
		
		spec	
			package: 'Ocompletion' with: 'Ocompletion-GuillermoPolito.116';
			package: 'OcompletionPharoCompatibility' with: 'OcompletionPharoCompatibility-GuillermoPolito.10';
			package: 'OcompletionTests' with: 'OcompletionTests-ul.10';
			package: 'RoelTyper' with: 'RoelTyper-FredericPluquet.82'.
			
		spec postLoadDoIt: #resetDefaultToolSet.
	].

	spec for: #'pharo1.3.x'  do: [
		spec
			package: 'OcompletionPharoCompatibility' with: 'OcompletionPharoCompatibility-GuillermoPolito.10'.
	].

	spec for: #squeak do: [
		
		spec 
			project: 'Shout' with: '1.1.1';
			project: 'Shout Tests' with: '1.1.1'.
		
		spec	
			package: 'Ocompletion' with: 'Ocompletion-MarianoMartinezPeck.98';
			package: 'OcompletionTests' with: 'OcompletionTests-ul.10';
			package: 'RoelTyper' with: 'RoelTyper-FredericPluquet.82'.
	]! !
